/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package FunctionLayer;

import com.google.common.collect.MapMaker;
import edu.stanford.nlp.pipeline.CoreDocument;
import edu.stanford.nlp.pipeline.CoreEntityMention;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.ConcurrentMap;

/**
 *
 * @author install1
 */
public class MessageResponseHandler {

    private static ConcurrentMap<Integer, String> str = new MapMaker().concurrencyLevel(2).makeMap();

    public static ConcurrentMap<Integer, String> getStr() {
        return str;
    }

    public static void setStr(ConcurrentMap<Integer, String> str) {
        MessageResponseHandler.str = str;
    }

    public static void getMessage(String message) {
        if (message != null && !message.isEmpty()) {
            message = message.replace("@", "");
            if (message.contains("<>")) {
                message = message.substring(message.indexOf(">"));
            }
            if (message.startsWith("[ *")) {
                message = message.substring(message.indexOf("]"));
            }
            str.put(str.size() + 1, message);
        }
    }

    public synchronized static String selectReponseMessage(String toString, String mostRecentMsg, String personName) throws CustomError {
        ConcurrentMap<Integer, String> str1 = new MapMaker().concurrencyLevel(2).makeMap();
        str1.put(str1.size() + 1, toString);
        str1 = Datahandler.cutContent(str1, false);
        String strreturn = "";
        for (String str : str1.values()) {
            if (!str.isEmpty()) {
                strreturn = str;
            }
        }
        String getResponseMsg = Datahandler.instance.getResponseMsg(strreturn, mostRecentMsg);
        getResponseMsg = checkPersonPresentInSentence(personName, getResponseMsg, strreturn);
        return getResponseMsg;
    }

    private static String checkPersonPresentInSentence(String personName, String responseMsg, String userLastMessage) {
        //check if userlastmsg contains person as refference
        //check if first person is author or their person of mention
        String strreturn = responseMsg;
        CoreDocument pipelineCoreDcoument = new CoreDocument(responseMsg);
        CoreDocument pipelineCoreDcoumentLastMsg = new CoreDocument(userLastMessage);
        Datahandler.getPipeline().annotate(pipelineCoreDcoument);
        Datahandler.getPipeline().annotate(pipelineCoreDcoumentLastMsg);
        try {
            for (CoreEntityMention em : pipelineCoreDcoument.entityMentions()) {
                String entityType = em.entityType();
                if (entityType.equals("PERSON")) {
                    try {
                        String str = strreturn;
                        String emText = em.text();
                        if (!emText.equals(personName)) {
                            for (CoreEntityMention emLastMsg : pipelineCoreDcoumentLastMsg.entityMentions()) {
                                if (!emText.equals(emLastMsg.text())) {
                                    str = strreturn.replaceFirst(emText, emLastMsg.text());
                                }
                            }
                            try {
                                str = str.replace(str.substring(str.lastIndexOf(emText), str.length()), personName);
                            } catch (Exception e) {
                                System.out.println("failed replacing: " + e.getLocalizedMessage() + "\n");
                            }
                            return str;
                        }
                    } catch (Exception e) {
                        System.out.println("failed person replacement: " + e.getLocalizedMessage() + "\n");
                    }
                }
            }
        } catch (Exception e) {
            System.out.println("SCUFFED JAYZ: " + e.getLocalizedMessage() + "\n");
        }
        return responseMsg;
    }
}
