/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Presentation;

import FunctionLayer.RecentTimes;
import FunctionLayer.Caching.GACaching;
import FunctionLayer.ErrorMessageDisplay;
import FunctionLayer.MapBoard;
import FunctionLayer.UserBanners;
import FunctionLayer.Users;
import java.util.List;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 *
 * @author install1
 */
public class SessionAttributeHandler extends Command {

    /**
     * SessionAttributeHandler redirects all required calls to clients
     *
     * @param request
     * @param response
     * @return
     * @throws ErrorMessageDisplay
     */
    @Override
    String execute(HttpServletRequest request, HttpServletResponse response) throws ErrorMessageDisplay {
        HttpSession session = request.getSession();
        GACaching.instance.Initialization();
        List<MapBoard> mapBoard = GACaching.instance.getAllMapValues();
        List<RecentTimes> recentTimes = GACaching.instance.getAllRecentTimes();
        List<UserBanners> UB = GACaching.instance.getUserBanners();
        List<Users> PlayerLeaderBoard = GACaching.instance.getAllPlayerValues();
        if (mapBoard.size() < 1) {
            throw new ErrorMessageDisplay("No maps available, call jenz");
        }
        session.setAttribute("LeaderBoard", PlayerLeaderBoard);
        session.setAttribute("MapBoard", mapBoard);
        session.setAttribute("UserBanners", UB);
        session.setAttribute("RecentTimes", recentTimes);
        return "Content";
    }

}
